unit AxisIssue;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, ExtCtrls, TeeProcs, Chart, StdCtrls, CheckLst, Series;

type
  TForm3 = class(TForm)
    CheckListBox1: TCheckListBox;
    Chart1: TChart;
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure ChartAxisOnDrawLabel(Sender: TChartAxis; var X, Y,
      Z: Integer; var Text: string; var DrawLabel: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    fLastLabelPos: Integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

procedure TForm3.ChartAxisOnDrawLabel(Sender: TChartAxis; var X, Y,
  Z: Integer; var Text: string; var DrawLabel: Boolean);
begin
  DrawLabel := Sender.LabelWidth(X) + Trunc(Sender.LabelsSeparation / 2) < X - fLastLabelPos;
  if DrawLabel then
  begin
    fLastLabelPos := X;
  end;
end;

procedure TForm3.CheckListBox1ClickCheck(Sender: TObject);
var
  i, j: Integer;
  ABarSeries: TBarSeries;
  ADateString: string;
  AValue: double;
begin
  fLastLabelPos:= -1;
  Chart1.SeriesList.Clear;
  for i := 0 to CheckListBox1.Items.Count - 1 do
  begin
    if CheckListBox1.Checked[i] then
    begin
      ABarSeries:= TBarSeries.Create(Chart1);
      ABarSeries.ParentChart:= Chart1;
      ABarSeries.Title:= CheckListBox1.Items[i];
      ABarSeries.Marks.Visible:= False;
      ABarSeries.BarPen.Visible:= False;
      ABarSeries.Transparency:= 50;
      for j := 0 to 300 do
      begin
        ADateString:= FormatDateTime('dd/MM/yyyy', Date - 300 + j);
        AValue:= Random(10000) / 100;
        ABarSeries.Add(AValue, ADateString);
      end;
    end;
  end;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  Chart1.BottomAxis.OnDrawLabel:= ChartAxisOnDrawLabel;
end;

end.
